# -*- perl -*-

# Copyright (c) 2002 by Jeff Weisberg
# Author: Jeff Weisberg <argus @ tcp4me.com>
# Date: 2002-Apr-02 11:06 (EST)
# Function: misc code
#
# $Id: misc.pl,v 1.13 2002/10/20 22:32:15 jaw Exp jaw $

# My lord the emperor, resolve me this:
#  -- Shakespeare, Titus Andronicus
# memoized gethostbyname
my %resolve = ();
sub resolve {
    my( $a ) = @_;
    my( $ip, @o );

    # skip DNS lookups if only checking the config file
    return "addr" if $::opt_t && !$::opt_T;
    
    return $resolve{$a} if( $resolve{$a} );
    
    if( $a =~ /^\d+\.\d+\.\d+\.\d+$/ ){
        @o = split( /\./, $a );
        $ip = pack ("CCCC", @o);
    }else{
        $ip = gethostbyname($a);
        if( length($ip) != 4){
            sleep(1);
            $ip = gethostbyname($a);
        }
    }
    $resolve{$a} = $ip;
    $ip;
}

sub inet_aton {
    my($a) = shift;
    my(@octet) = split /\./, $a;

      $octet[0]<<24
    | $octet[1]<<16
    | $octet[2]<<8
    | $octet[3];
}

sub inet_ntoa {
    my($a) = unpack( "N", shift );

    sprintf "%d.%d.%d.%d", ($a>>24), ($a>>16) & 0xFF, ($a>>8) & 0xFF, $a & 0xFF;
}

sub ckbool {
    my $v = shift;

    ($v =~ /yes|true|on|1/i) ? 1 : 0;
}


# modification of quoted-printable encoding
# encode chars that will cause problems with webpages, etc
sub xxx_encode {
    my $txt = shift;

    $txt =~ s/([ \r\n%\+\\\;=\"\'\`\?\&~<>\/\000-\037\200-\377])/sprintf("~x%02X",ord($1))/ge;
    $txt;
}

# And so of these. Which is the natural man,
# And which the spirit? who deciphers them?
#  -- Shakespeare, Comedy of Errors
sub xxx_decode {
    my $txt = shift;

    $txt =~ s/~x(..)/chr(hex($1))/ge;
    $txt;
}

# And these does she apply for warnings, and portents,
# And evils imminent; and on her knee
#  -- Shakespeare, Julius Ceasar
sub warning {
    my $msg = shift;

    loggit( $msg, 1 );
}

sub xxx_openlog {
    if( $Conf::Config{syslog} ){
	print STDERR "opening syslog: $Conf::Config{syslog}\n" if $::opt_d;
	eval {
	    # this is only in $VER > $X
	    setlogsock( 'unix' );
	};
	openlog( $NAME, 'pid ndelay', $Conf::Config{syslog} );
    }
}

# And there was found at Achmetha, in the palace that is in the province
# of the Medes, a roll, and therein was a record thus written:
#   -- ezra 6:2
sub loggit {
    my $msg = shift;
    my $lfp = shift;
    my( $date, @d );

    # When they had thrown down their great logs of wood over the whole ground
    #   -- Homer, Iliad
    @d = localtime;
    $date = sprintf "%d/%d/%d %d:%0.2d:%0.2d",
        $d[5]+1900, $d[4]+1, $d[3], $d[2], $d[1], $d[0];

    syslog( 'info', $msg )  if $Conf::Config{syslog};
    print STDERR "$msg\n"   if $opt_f;
    
    Control::console( $msg );
    if( $lfp && $datadir ){
	open  LOG, ">> $datadir/log";
	print LOG "[$date] [$$] $msg\n";
	close LOG;
    }
}

sub trace {

    print STDERR join(", ", caller(0)), "\n";
    print STDERR join(", ", caller(1)), "\n";
    print STDERR join(", ", caller(2)), "\n";
    print STDERR join(", ", caller(3)), "\n";
    print STDERR join(", ", caller(4)), "\n";
    print STDERR join(", ", caller(5)), "\n";
    print STDERR join(", ", caller(6)), "\n";
    print STDERR "----\n";
}

sub pnow {
    print STDERR scalar(localtime $^T), "\n";
}

1;
